package com.mortals.xhx.module.care.web;
import cn.hutool.core.util.StrUtil;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.base.system.user.model.UserQuery;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.common.code.IdCardTypeEnum;
import com.mortals.xhx.module.appointment.model.AppointmentConstraintEntity;
import com.mortals.xhx.module.person.model.PersonQuery;
import com.mortals.xhx.module.person.service.PersonService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.care.model.CareConstraintEntity;
import com.mortals.xhx.module.care.service.CareConstraintService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import java.util.Arrays;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 主动关怀服务约束
*
* @author zxfei
* @date 2023-04-09
*/
@RestController
@RequestMapping("care/constraint")
public class CareConstraintController extends BaseCRUDJsonBodyMappingController<CareConstraintService,CareConstraintEntity,Long> {

    @Autowired
    private ParamService paramService;
    @Autowired
    private PersonService personService;
    @Autowired
    private UserService userService;

    public CareConstraintController(){
        super.setModuleDesc( "主动关怀服务约束");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "createWay", paramService.getParamBySecondOrganize("CareConstraint","createWay"));
        this.addDict(model, "track", paramService.getParamBySecondOrganize("CareConstraint","track"));
        this.addDict(model, "idCardType", IdCardTypeEnum.getEnumMap());

        Map<String, String> personCollect = personService.find(new PersonQuery()).stream()
                .collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getName(), (o, n) -> n));
        this.addDict(model, "personId", personCollect);

        Map<String, String> collect = userService.find(new UserQuery(), getContext()).stream()
                .collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getRealName(), (o, n) -> n));
        this.addDict(model, "operator", collect);
        this.addDict(model, "createUserId", collect);


        super.init(model, context);
    }

    @Override
    protected int doListAfter(CareConstraintEntity query, Map<String, Object> model, Context context) throws AppException {

        List<CareConstraintEntity> list = (List<CareConstraintEntity>) model.get(KEY_RESULT_DATA);
        list.forEach(item -> {
            String maskedIdNumber = StrUtil.hide(item.getIdCard(), 4, item.getIdCard().length() - 4);
            item.setIdCard(maskedIdNumber);
        });
        return super.doListAfter(query, model, context);
    }
}